module annot(annR) where

import FlatCurry   -- It defines flat curry structures

import fptypes     -- It includes graph definitions
import fpqs        -- It includes qs
import fplinear    -- It includes linear function
import fpgraph     -- It includes getGraph function


annR :: Prog ->  Prog
annR (Prog modn imp typ funs opd) = (Prog modn imp typ ((map (annF g) funs)++fdgen) opd)
   where
      g = getGraph (Prog modn imp typ funs opd)
      fdgen = [(Func (modn,"GEN") 1 Public (FuncType (TVar 0) (TVar 0)) (Rule [0] (Var 0)))]


-- annF takes the graph of the program and a function declaration and
-- returns a new function declaration

annF :: Graph -> FuncDecl -> FuncDecl
annF g f = if (nodeG (getNameF f) g)==C then linearF (qsF f)    
                                        else linearF f

-- nodeG simply looks for the value of a node in a graph:

nodeG :: String -> Graph -> Characs
nodeG _  []    = NC
nodeG nf ( (n,_,ch) :gs) = if n==nf then ch else nodeG nf gs

-- getNameF takes a function declaration and returns the
-- (non-qualified) name of the function

getNameF :: FuncDecl -> String
getNameF ( Func (_,nf) _ _ _ _ ) = nf

existfdgen ::[FuncDecl] -> Bool
existfdgen [] = False
existfdgen ((Func (_,name) _ _ _ _):funs) = if name == "GEN" then True 
                                                   else existfdgen funs
