import System --for benchmarking

data Nat = Z | S Nat

--deforestation (no static data):

main xs = allones (length2 xs)


allones Z = []
allones (S x) = 1:(allones x)

length2 [] = Z
length2 (_:xs) = S (length2 xs)


--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main [1..100000]))
        where x free


