import System --for benchmarking

data Nat = Z | S Nat


main xs = applast xs 6

applast xs x = last (app xs [x])

app [] y = y
app (x:xs) y = x : app xs y

last [x] = x
last (x:y:ys) = last (y:ys)

--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main [1..100000]))
        where x free


