import System --for benchmarking

data Nat = Z | S Nat

data TreeInt = Leaf Nat | Tree Nat TreeInt TreeInt

--specialized for a binary tree of depth 10 or more:

main t = fliptree  (gentree (S (S (S (S (S (S (S (S (S (S t)))))))))))

-- generate a treee of depth n:
gentree Z    = Leaf Z
gentree (S n)= Tree (S n) (gentree n) (gentree n)

fliptree (Leaf a) = Leaf a
fliptree (Tree (S n) l r) = Tree n (gentree n) (gentree n)

--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main (S (S (S (S (S (S Z))))))))
        where x free

