import System --for benchmarking

data Nat = Z | S Nat


main xs = geqSubList (S (S (S (S (S (S (S Z))))))) xs 

geqSubList _ [] = []
geqSubList n (x:xs) = ite (geq x n) ((fact x) : leqSubList n xs) (leqSubList n xs)

leqSubList _ [] = []
leqSubList n (x:xs) = ite (leq x n) ((fact x) : geqSubList n xs) (geqSubList n xs)

geq Z Z = True
geq (S _) Z = True
geq Z (S _) = False
geq (S x) (S y) = geq x y

leq Z _ = True
leq (S _) Z = False
leq (S x) (S y) = leq x y

ite True x _ = x
ite False _ y = y

fact Z = S Z
fact (S x) = mult (S x) (fact x)

mult Z     n  = Z
mult (S v) n  = sum n (mult v n)

sum Z     n = n
sum (S v) n = S (sum v n)


--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main 
  [S (S (S (S Z))), S (S (S Z)), S (S (S Z)), S (S (S Z)), S (S (S Z)), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), S (S (S (S (S (S (S Z)))))), 
   S (S (S Z)), S (S (S Z)), S (S (S Z)), S (S (S Z)), S (S (S Z))
  ]))
  where x free

