import System --for benchmarking

data Nat = Z | S Nat

--deforestation (no static data):

main xs = sincList xs (S (S (S (S (S (S (S (S (S (S Z))))))))))

sincList [] _ = Z
sincList (x:r) i = siList x r i

siList x r i = add (add i x) (sincList r i)

add Z y = y
add (S x) y = S (add x y)

--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main (genListSSSSZ 20000)))
        where x free

genListSSSSZ n = if n==0 then [] else S (S (S (S Z))) : genListSSSSZ (n-1)
