import System --for benchmarking

data Nat = Z | S Nat

--
main xs = insert (S (S (S (S (S (S (S (S (S (S Z)))))))))) (insert_sort xs)

insert_sort [] = []
insert_sort (x:xs) = insert x (insert_sort xs)

insert e [] = [e]
insert e (x:xs) = ite (geq e x) ((GEN x) : insert (GEN e) xs)
                                ((GEN e) : (GEN x) : (GEN xs))

geq _ Z = True
geq Z (S _) = False
geq (S x) (S y) = geq x y

ite True x _ = x
ite False _ y = y

--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main (genListSSSSZ 500)))
        where x free

genListSSSSZ n = if n==0 then [S (S (S (S (S (S (S (S (S (S Z)))))))))] 
                         else S (S (S (S Z))) : genListSSSSZ (n-1)
