import System --for benchmarking


data Token = Cst Int 
           | Var Int 
           | Plus Token Token 
           | Minus Token Token 
           | Fun Foo

data Foo = One | Rec

int :: Token -> [Int] -> [Int] -> Int
int (Cst x) _ _ = x
int (Var x) vars vals = lookup x vars vals
int (Plus x y) vars vals = (int x vars vals) + (int y vars vals)
int (Minus x y)  vars vals = (int x vars vals) - (int y vars vals)
int (Fun x) vars vals = int (def0 x) vars vals

def0 One = Cst 1
def0 Rec = Fun Rec

lookup x (v:vs) (val:vals) = if x==v
                                then val
                                else lookup x vs vals 

--specialized for a particular expression (but the values of
--variables in the environment are unknown)

main x = PEVAL (int (Plus (Minus (Var 1) (Var 2))
                          (Plus (Minus (Var 4) (Var 3)) 
                                (Minus (Var 4) (Var 2)))) 
                    [1,2,3,4] x)

--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main [20,25,21,23])) 
        where x free

