import System --for benchmarking


data Token = Cst Nat --Int 
           | Var Nat --Int 
           | Plus Token Token 
           | Minus Token Token 
           | Fun Foo

data Foo = One | Rec

data Nat = Z | S Nat


--specialized for a particular expression (but the values of
--variables in the environment are unknown)

main x = int (Plus (Minus (Var (S Z)) (Var (S (S Z))))
                   (Minus (Var (S (S (S (S Z))))) (Var (S (S (S Z)))))
                   )
                         --(Minus (Var (S (S (S (S Z))))) (Var (S (S Z)))))) 
             [S Z, S (S Z), S (S (S Z)), S (S (S (S Z)))] x


--int :: Token -> [Int] -> [Int] -> Int
int (Cst x) _ _ = x
int (Var x) vars vals = lookup x vars vals
int (Plus x y) vars vals = add (int x vars vals) (int y vars vals)
int (Minus x y)  vars vals = subs (int x vars vals) (int y vars vals)
int (Fun x) vars vals = int (def0 x) vars vals

def0 One = Cst (S Z)
def0 Rec = Fun Rec

lookup x (v:vs) (val:vals) = if (eq x v)
                                then val
                                else lookup x vs vals 

eq Z Z = True
eq Z (S _) = False
eq (S _) Z = False
eq (S x) (S y) = eq x y

add Z y = y
add (S x) y = S (add x y)

subs x Z = x
subs (S x) (S y) = subs x y

--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main [nat 6600,nat 250,nat 210,nat 5100])) 
        where x free

nat n = if n==0 then Z else S (nat (n-1))