module power_ann where

import System

data Nat
     = Z
     | S Nat

main :: Nat -> Nat
main x = pow x (S (S (S (S Z))))

pow :: Nat -> Nat -> Nat
pow x Z = S Z
pow x (S n) = mult x (pow (GEN x) n)

mult :: Nat -> Nat -> Nat
mult Z n = Z
mult (S v) n = sum n (mult v (GEN n))

sum :: Nat -> Nat -> Nat
sum Z n = n
sum (S v) n = S (sum v n)

GEN :: a -> a
GEN x = x

getExecTime :: IO a -> IO Int
getExecTime act = 
    do
     time1 <- getCPUTime
     act
     time2 <- getCPUTime
     return (time2 - time1)

runBenchmark :: Int -> (Int -> IO a) -> IO ()
runBenchmark i b = 
    do
     times <- sequenceIO $ (take i (map (getExecTime . b) (repeat 1)))
     putStrLn $ ("Runtimes (msecs): " ++ (show times))
     putStrLn $ ("Average (msecs): " ++ (show (div (foldr ((+)) 0 times) (length times))))

bench :: IO ()
bench = runBenchmark 10 (\_ -> print (x =:= (main (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S Z)))))))))))))))))))))))))
   where
     x free
