module fplinear (linearF) where

import FlatCurry
import fptypes

-- ESTE MODULO PERMITE LINEALIZAR UNA FUNCION


---------------------------------------------------------------------------------------
-- The first section only reaches the maximum var number of one function
---------------------------------------------------------------------------------------

linearF :: FuncDecl -> FuncDecl 
linearF ( Func a b c d (External      e) ) = ( Func a b c d (External      e ) )
linearF ( Func a b c d (Rule rule  prhs) ) = let maxv = foldr maxi (-1) rule 
                                             in (Func a b c d (Rule rule (intoPatt maxv prhs)))

intoPatt :: Int -> Expr -> Expr
intoPatt m e =
  case e of
    Case ct (Var n) bs -> Case ct (Var n) (map (intoBr (maxi m n)) bs)
    _                  -> let (_,_,expr)=linearExpr [] m e in expr


intoBr :: Int -> BranchExpr -> BranchExpr
intoBr n (Branch (Pattern qn varB) expr) = let m = foldr maxi (-1) (n:varB)
                                           in (Branch (Pattern qn varB) (intoPatt m expr))


---------------------------------------------------------------------------------------
-- The second section is for get linearity
---------------------------------------------------------------------------------------

linearExpr :: [VarIndex] -> Int -> Expr ->([VarIndex], Int, Expr)
linearExpr vars count e =
 case e of 
  Var x              -> linearize x vars count  
  Comb ConsCall qn es-> let (vs,c,w)=processCons vars count es in (vs,c,(Comb ConsCall qn w))
  Comb FuncCall qn es-> processF qn vars count es
  _                  -> (vars,count,e)

                                                             --gad11ago06
--linearize x vars count  =  if (elem x vars) then (vars, c, (Comb FuncCall ("prelude","bullet") [Var x]))--(Var c))
linearize x vars count  =  if (elem x vars) then (vars, c, (Comb FuncCall ("prelude","GEN") [Var x]))--(Var c))
                           else (    (x:vars),  count, (Var x)      ) 
                                where c= count + 1


-- PROCESSCONS Y PROCESSFUNC SON IGUALES, CAMBIAR NOMBRE Y USAR UNA SOLA processComb

processCons vars count []     = (vars,count,[])
processCons vars count (e:es) = (v2,c2, (ex:e2))
   where
      (v,c,ex  ) = linearExpr vars count e
      (v2,c2,e2) = processCons v c es

--processF (mn,fn) vars count es =                              -- no interesa inside bullet
--  if (fn=="bullet") then let (_,c,w)=processFunc [] count es  -- is a new scope, it'll generalize to x
processF (mn,fn) vars count es =                              
  if (fn=="GEN") then let (_,c,w)=processFunc [] count es  
                         in  (vars,c,(Comb FuncCall (mn,fn) w)  )
  else let (vs,c,w)=processFunc vars count es 
       in  (vs,c,(Comb FuncCall (mn,fn) w))

processFunc vars count []     = (vars,count,[])
processFunc vars count (e:es) = (v2,c2,(ex:e2))
   where
      (v,c,ex  ) = linearExpr vars count e
      (v2,c2,e2) = processFunc v c es
