--  En esta version 8 el goal es procesar nested functions    
-- esta version aun coserva tipos ORDER como Equ y GrT            


--El objetivo es
-- -2. Leer fichero
-- -1. Crear grafos
-- 0. crear grafos en funciones anidadas
-- 1. resolver la concatenacion de los grafos (GUARDANDO NODOS INTERMEDIOS)
-- 2. calcular la cerradura de grafos de jones

import AbstractCurry
import Unsafe
import List

testing = False

----------------- size change graph types --------------------------
type Fname  = String   --- function name
type Arity  = Int      --- function arity
type Src    = Int      --- source node
type Tgt    = Int      --- target node
data Order  = GrT | Equ            
type Edge = (Src, Tgt, Order)
------------------------f---------------g----------arches-----------
data   Graph = G (Fname,Arity) (Fname,Arity) [Edge] 
data  MGraph = MG Graph [Graph]
--------------------------------------------------------------------


--test :: Expr -> Int -> Expr 
--test exp = if (testing == True)
--           then trace exp
--           else exp



--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
--  FUNCTIONS in order to EXPLORE A PROGRAM AND extrac its S.CH.GRAPHS 
--------------------------------------------------------------------------------------------------


mainFoo file =
   do 
    putStrLn "--------------------------------------------------"
    putStrLn "         Building graphs           v 0.1.0        "
    putStrLn "--------------------------------------------------"    
    putStrLn "Loading AbstractCurry program"
    prog <- (readCurry file)
    putStrLn "Program Loaded"
    putStrLn "Getting graphs from program..."
    let graphs  = getGProg prog
    putStrLn "Dirty graphs are..." 
    putStrLn (concatMap showG graphs)
    let cleargr =   map (clearG) graphs 
    putStrLn "Clear graphs are..." 
    putStrLn (concatMap showG cleargr)
    putStrLn "Calculating Jones Closure..."    
    let maxis   = maximal cleargr          -- maximal (delGRepeated cleargr [] )
    putStrLn  ("There are "++ (show (length maxis) ) ++ " maximal graphs...")
    putStrLn (concatMap showG maxis)
  

showG g = "\n g.- \t" ++ (show g)


getGraphs fichero =
    let 
       graphs  = getGProg fichero
       cleargr =  nub (map (clearG) graphs)
       maxis   = maximal cleargr
     in maxis


getGProg :: CurryProg -> [MGraph]
getGProg (CurryProg m i t functions o)  = 
         concatMap (getGFun flist) functions
  where flist=(extractFNames (CurryProg m i t functions o))



-- This function get info from a single function of an AbstractCurry program

getGFun :: [(String,Int )]->  CFuncDecl -> [MGraph]
getGFun    fs (CFunc (_,fname) ar _ _ rules) =  getGRules fname ar fs rules 


getGRules :: String -> Int -> [(String,Int)] -> CRules ->  [MGraph]
getGRules fname ar fs (CRules _ rules)  = concatMap  (getGRule fname ar fs) rules
getGRules _     _  _  (CExternal _   )  = []


-----------------------------------------------------------------------------------
-- getGRule : extract info from a rule, from right hand side and from patterns 
--            and make the graphs for this rule
-- receives : a function list and a rule
-- returns  : the graphs of this function

getGRule :: String -> Int -> [(String,Int)] -> CRule ->  [MGraph]
getGRule fname ar fs (CRule patterns rhss _) = 
                     --(trace ("\n"++(show rhssInfo)++(show pattInfo))) 
                     makeSCHGrule fname ar fs (map (vInPs patterns 1) pattInfo) rhssInfo
     where  pattInfo    = concatMap (depthP 0 []) patterns
            (_,rhssInfo)= getGInfoRhss 0 fs rhss
----------------------------------------------------------------------------------  
getGInfoRhss c _  []     = (c,[])
getGInfoRhss c fs (r:rs) =  let  (c1,l1) = getGInfoRhss c fs rs
                                 (c2,l2) = getGRhs c1 fs r
                             in  (c2,l1++l2)     
-----------------------------------------------------------------------------------

-- This function explore one right hand side of a rule

getGRhs :: Int-> [(String,Int)] -> (CExpr,CExpr) -> (Int, [(String, Int, String,Int)])
getGRhs c fs ( _ ,expr) = getGExpr c fs expr


-- This function anotates an expression

getGExpr :: Int -> [(String,Int)] -> CExpr -> (Int, [(String, Int, String,Int)])
getGExpr c _  (CVar _)       = (c,[])
getGExpr c _  (CLit _)       = (c,[])
getGExpr c _  (CSymbol _)    = (c,[])
getGExpr c fs (CApply expr1 expr2) = getGApp c fs (CApply expr1 expr2)
getGExpr c _  (CLambda _  _) = (c,[]) 
getGExpr c fs (CLetDecl lDecls expr) = let (c1,l1) = (getGDecls c fs lDecls )
                                           (c2,l2) = (getGExpr c1 fs expr)
                                       in  (c2,l1++l2)
getGExpr c fs (CDoExpr statements)   = (getGSts   c fs statements)
getGExpr c fs (CListComp expr statements) = let (c1,l1)=(getGExpr c fs expr)
                                                (c2,l2)=(getGSts c1 fs statements)
                                            in  (c2,l1++l2)
getGExpr c fs (CCase expr branches)       = let (c1,l1)=(getGExpr c fs expr)
                                                (c2,l2)=(getGBrs c1 fs branches)
                                            in  (c2,l1++l2)



-- This function explores a list of local declarations

getGDecls :: Int -> [(String,Int)]-> [CLocalDecl] -> (Int, [(String, Int, String,Int)])
getGDecls c fs lDecls = getGInfolDecls c fs lDecls    --concatMap (getGDecl c fs) lDecls

getGInfolDecls c _     []    = (c,[])
getGInfolDecls c fs (ld:lds) = let (c1,l1) = getGInfolDecls c fs lds
                                   (c2,l2) = getGDecl  c1 fs ld
                             in  (c2,l1++l2)


-- This function explores a single local declaration

getGDecl ::  Int -> [(String,Int)] -> CLocalDecl -> (Int, [(String, Int, String,Int)])
--getGDecl fs (CLocalFunc funcDecl     ) = (getGFun  fs funcDecl) -- local function declaration
getGDecl c fs (CLocalPat _  expr lDecls) = let (c1,l1)=(getGExpr c fs expr)
                                               (c2,l2)=(getGDecls c1 fs lDecls)
                                           in  (c2,l1++l2)  
getGDecl c _  (CLocalVar _             ) = (c,[]) -- local free variable declaration


-- This function explores a list of statements

getGSts ::Int ->  [(String,Int)] -> [CStatement] ->(Int,  [(String, Int, String,Int)])
getGSts c fs sts =  getGInfoSts c fs sts  ---concatMap (getGSt c fs) sts

getGInfoSts c _     []    = (c,[])
getGInfoSts c fs (st:sts) = let (c1,l1) = getGInfoSts c fs sts
                                (c2,l2) = getGSt     c1 fs st
                             in (c2,l1++l2)


-- This function explores a single statement

getGSt ::Int -> [(String,Int)] ->  CStatement ->  (Int,[(String, Int, String,Int)])
getGSt c fs (CSExpr    expr) = (getGExpr  c fs expr)   -- an expression (I/O action or boolean)
getGSt c fs (CSPat _   expr) = (getGExpr  c fs expr)   -- a pattern definition
getGSt c fs (CSLet   lDecls) = (getGDecls c fs lDecls) -- a local let declaration


-- This function explores a list of branches

getGBrs ::Int ->  [(String,Int)]->[CBranchExpr] -> (Int, [(String, Int, String,Int)])
getGBrs  c fs brs = getGInfoBrs c fs brs  ---concatMap (getGBr c fs) brs

getGInfoBrs c _     []    = (c,[])
getGInfoBrs c fs (br:brs) = let (c1,l1) = getGInfoBrs c fs brs
                                (c2,l2) = getGBr      c1 fs br
                            in  (c2,l1++l2)

-- This function explores a single branch

getGBr :: Int -> [(String,Int)]->CBranchExpr -> (Int, [(String, Int, String,Int)])
getGBr  c fs (CBranch  _  expr) =  (getGExpr c fs expr)


------------------------------------------------------------------------------
-- getGApply : get graphs from a function application  
-- receives  : an expression of an funcion application 
-- returns   : a lis for create graphs
getGApp :: Int -> [(String,Int)]-> CExpr -> (Int, [(String, Int, String,Int)])
getGApp c fs (CApply e1 e2)  =  
            if isFunc 
               then getEdges  (c+1) fs (CApply e1 e2) fname2 args
               else let (c1,l1)=(getGExpr  c fs e1) 
                        (c2,l2)=(getGExpr c1 fs e2)
                    in  (c2,l1++l2) 
       where (isFunc,fname, args) = isfuncInApp fs (CApply e1 e2)
             fname2 = (fname++ "_" ++ (show c))
 
isfuncInApp fs (CApply expr1 _ )=
     case expr1 of
         (CApply e3 e4    )->isfuncInApp fs (CApply e3 e4)
         (CSymbol (_,name))->if (elem name (map fst fs)) 
                                 then (True,name,(arityF name fs)) 
                                 else (False,"",0)
         _                 -> (False,"",0)

arityF fname ((f,a):fs) = if fname==f 
                             then a
                             else arityF fname fs
------------------------------------------------------------------------------


------------------------------------------------------------------------------
-- getEdges : analyzes an argument of a function application 
-- receives : an CApply expression, function name, arg pos
-- returns  : a list of info for graph creating

getEdges:: Int -> [(String,Int)] -> CExpr -> String -> Int -> (Int, [(String, Int, String,Int)])
getEdges  c fs (CApply e1 e2) fname argpos =
         if (argpos > 0)
            then if (isConsApp e2 (map fst fs) ) 
                     then let  l1     = (createNodes   e2 fname argpos) 
                               (c2,l2)= (getEdges c fs e1 fname (argpos - 1)) 
                          in (c2,l1++l2) 
                     else let (c1,l1)= (getEdges c fs e1 fname (argpos - 1)) 
                              (c2,l2)= (getGExpr c1 fs e2)
                          in  (c2,l1++l2)
            else (c,[]) 
getEdges  c _ (CSymbol _ ) _ _ = (c,[])
------------------------------------------------------------------------------


------------------------------------------------------------------------------
-- createNodes: creates the nodes for an argument of a function
-- receives   : a constructor expression, the function name, and the argument number
-- returns    : a list with the information for creating edges (func, pos, var, depht)

createNodes :: CExpr -> String -> Int -> [(String, Int, String,Int)]
createNodes    e fname argpos =
               let (_,l) = depth e (0,[])
               in          map (createAnode fname argpos) l

createAnode  fname argpos (variable,d) = (fname,argpos,variable,d)

-- test with (S (A x y))
tst_createNodes=createNodes (CApply (CSymbol ("ejeAcy4","S")) (CApply (CApply (CSymbol ("ejeAcy4","A")) (CVar (0,"x"))) (CVar (1,"y")))) "g" 2
------------------------------------------------------------------------------



------------------------------------------------------------------------------
-- depth   : search variables and calculates their depth    
-- receives: a constructor application and
-- returns : a list of pairs (variable, depth)
-- to customize pakcs 1.6.0 it puts de in of let on the last let instruction 

depth :: CExpr -> (Int, [(String, Int)]) -> (Int, [(String, Int)])
depth    expr (d,l) = 
         case expr of
             (CApply e1 e2) -> let  (d1,l1)= depth e1 (d,l)
                                    (d2,l2)= ( (d1+1), l1 )
                                    (d3,l3)= depth e2 (d2,l2)
                                    (d4,l4)= ( (d3-1), l3)  in (d4,l4)
             (CSymbol _ )   -> (d,l)
             (CVar (_,name))-> (d, (l++[(name,d)]) )  
             _              -> (0,[])

  
--test with (S (S x))
tst_depth=depth (CApply (CSymbol ("ejeAcy4","S")) (CApply (CSymbol ("ejeAcy4","S")) (CVar (0,"x")))) (0,[])
--test with (S (A x y))
tst_depth2=depth (CApply (CSymbol ("ejeAcy4","S")) (CApply (CApply (CSymbol ("ejeAcy4","A")) (CVar (0,"x"))) (CVar (1,"y")))) (0,[])
------------------------------------------------------------------------------



------------------------------------------------------------------------------
-- depth   : search variables and calculates their depth in a Pattern    
-- receives: a constructor application and
-- returns : a list of pairs (variable, depth) 

depthP :: Int -> [(String, Int)] -> CPattern -> [(String, Int)]
depthP    d l expr  = 
         case expr of
             (CPVar (_,name))-> l ++ [(name,d)]
             (CPLit   _     )-> l
             (CPComb  _  ls )-> concatMap (depthP (d+1) l) ls

--   aqui se prueba la adquisicion de variable con posicion, nombre, prof
tst_dephtP =  map (vInPs patron 1) (concatMap (depthP 0 []) patron)
patron     = [(CPComb ("ejeAcy6","S") [(CPComb ("ejeAcy6","S") [(CPComb ("ejeAcy6","S") [(CPComb ("ejeAcy6","S") [(CPComb ("ejeAcy6","A") [(CPVar (0,"x")),(CPVar (1,"y"))])])])])]),(CPComb ("ejeAcy6","S") [(CPComb ("ejeAcy6","S") [(CPComb ("ejeAcy6","S") [(CPComb ("ejeAcy6","A") [(CPVar (2,"z")),(CPComb ("ejeAcy6","S") [(CPComb ("ejeAcy6","S") [(CPVar (3,"w"))])])])])])])]


vInPs  []    pos (v,d) = (pos,v,d) -- this is impossible
vInPs (p:ps) pos (v,d) = 
    if (vInP v p) then (pos,v,d)
              else vInPs ps (pos+1) (v,d)

vInP v p= case p of
            (CPVar (_,vname)) -> if vname == v then True else False
            (CPLit  _       ) -> False
            (CPComb _  patts) -> elem True (map (vInP v) patts)   

-----------------------------------------------------------------------------


------------------------------------------------------------------------------
-- isConsApp : verifies if it is a constructor application 
-- receives  : an Apply expression
-- returns   : True, if it's a contructor applications (not function symbols)

isConsApp :: CExpr -> [String] -> Bool
isConsApp    expr funs =   
             case expr of
                 (CApply e1 e2     ) -> isConsApp e1 funs  &&  isConsApp e2 funs
                 (CSymbol (_,fname)) -> not (elem fname funs)
                 (CVar _           ) -> True
                 _                   -> False


--test with (S (S x))
tst_isConsApp=isConsApp (CApply (CSymbol ("ejeAcy4","S")) (CApply (CSymbol ("ejeAcy4","S")) (CVar (0,"x")))) ["f","g"]
------------------------------------------------------------------------------



------------------------------------------------------------------------------
-- extractFNames : extracts the function names and their arities from a program
-- receives : an abstract curry program
-- returns  : a string list with the functions of the program

extractFNames :: CurryProg -> [(String, Int)]
extractFNames   (CurryProg _ _ _ functions _ )  =  map (extractAfname) functions


extractAfname :: CFuncDecl -> (String,Int)
extractAfname    (CFunc (_,fname) arity _ _ _ ) = (fname,arity)
------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- createSCHG : create de size change graphs for a rule
-- receives   : fname and arity, function list, pattern variables, and rule vars
-- returns    : the graphs for this rule

                               --  f   ,d  --    --pos  var   d --     --f   posarg  var  depth --  
makeSCHGrule::String -> Int -> [(String,Int)] -> [(Int,String,Int)] -> [(String,Int,String,Int)] -> [MGraph]
makeSCHGrule  fname ar fs pattInfo rhssInfo = 
           addEdgesAllVars fname ar fs [] pattInfo rhssInfo 
      
  
addEdgesAllVars   _     _    _   gs  _   []   = gs
addEdgesAllVars fnsrc arsrc fs   gs ps (v:vs) =
   addEdges1var fnsrc arsrc fs  ngs ps  v
   where
     ngs = addEdgesAllVars fnsrc arsrc fs gs ps vs     


tst_addArcs =addEdgesAllVars "f" 2 [("f",2),("g",2)] [] [(1,"x",1),(2,"y",0)] [("g",1,"x",1),("g",2,"y",0)]

addEdges1var    _    _    _   gs   []      _    = gs     
addEdges1var  fnsrc arsrc fs  gs (p:ps) varRhs  =
   addOneEdge fnsrc arsrc fs ngs        varRhs p
   where
     ngs = addEdges1var fnsrc arsrc fs gs ps varRhs


addOneEdge fn_s ar_s fs graphs (fn_t, pos_t, v_t, d_t) (pos_s, v_s, d_s) = 
  if v_s == v_t
     then if (elem True (map (ftInG fn_t) graphs))  
             then updateGrs fn_s ar_s fs graphs (fn_t, pos_t, v_t, d_t) (pos_s, v_s, d_s)
             else addNewGr  fn_s ar_s fs graphs (fn_t, pos_t, v_t, d_t) (pos_s, v_s, d_s)
     else graphs --(trace "\n *EE") graphs


-----------------------------------------------------------------------------------------------
-- crea un grafo a partir la info del pattern y una variable hallada en rhs
------------------------data   Graph = G (Fname,Arity) (Fname,Arity) [Arches] 

addNewGr fn_s ar_s fs graphs (fn_t, pos_t, _, d_t) (pos_s, _ , d_s)  =  
 if d_s >= d_t 
  then let g = G (fn_s,ar_s) (fn_t,ar_t) [(pos_s, pos_t,(order d_s d_t))] in (MG g [g]):graphs
  else let g = G (fn_s,ar_s) (fn_t,ar_t) []                               in (MG g [g]):graphs
  where   ar_t  = arityF (clear fn_t) fs   

clear s =  reverse (clearCh (reverse s))
clearCh (c:cs) = if c=='_' then cs else clearCh cs

order d_s d_t = if d_s > d_t then GrT else Equ
-----------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------
-- actualiza un grafo que ya existe, si es que hay un arco
--
-- to customize pakcs 1.6.0 it puts de in of let, on the last let instruction 

updateGrs fn_s ar_s fs graphs (fn_t, pos_t, v_t, d_t) (pos_s, v_s, d_s) =
  if d_s >= d_t 
     then updateG fn_s ar_s fs graphs (fn_t, pos_t, v_t, d_t) (pos_s, v_s, d_s)
     else graphs  

updateG  _  _  _  []  _  _  = []
updateG fn_s ar_s fs (g:grs) (fn_t, pos_t, v_t, d_t) (pos_s, v_s, d_s) =
  if (ftInG fn_t g) 
      then case g of
            (MG (G lf rf arches) _ )->let ng = (G lf rf ((pos_s,pos_t,(order d_s d_t)):arches)) in  (MG ng [ng]):grs
      else g:(updateG fn_s ar_s fs grs (fn_t, pos_t, v_t, d_t) (pos_s, v_s, d_s))

----------------------------------------------------------------------------------------------


ftInG fn_t (MG (G _ (ft,_) _) _ )= if fn_t==ft then True else False     





------------------------------------------------------------------------------


clearG (MG (G (fs,as) (ft,at) arches) _ ) = 
         let g = (G (fs,as) ((clear ft),at) arches) 
         in  (MG g [g])



--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
--                                          JONES CLOSURE ALGORITHMS
--===============================================================================================


----------------------------------------------------------------------
-- maximal gets the maximal graphs
--
maximal S = getMax (closure S)
getMax  S = concatMap isIdemp S
isIdemp g =  if (concatenable g g) then if (eqG g (ccat g g)) then [g]
                                                              else [ ]   
                                   else []
----------------------------------------------------------------------


----------------------------------------------------------------------
-- closure calculates Jones closure
--
closure S = if (eqSet S S2) then S2 
                     else computeS S2 S2 
               where S2 = computeS S S

computeS  []    Sacum = Sacum
computeS (g:gs) Sacum = computeS gs (computeGinS g Sacum Sacum)                                   

----------------------------------------------------------------------                                                                

----------------------------------------------------------------------
-- computing one graphs w.r.t. the all elementes in set S, returns the updatet set
---
computeGinS  _ []      Ssrc = Ssrc 
computeGinS  g (s:ss)  Ssrc = computeGinS g ss (compute2G g s Ssrc)     -- intenta concatenar g  
                                                                        -- con todos en S 
----------------------------------------------------------------------



----------------------------------------------------------------------
-- computing two graphs, one by one, w.r.t. the set S
---
compute2G:: MGraph -> MGraph -> [MGraph] -> [MGraph]
compute2G g1 g2 S = if (concatenable g1 g2)                           -- si se pueden concatenar
                         then  let g12 = ccat g1 g2                   -- se concatena, si no esta
                               in  if (elem True (map (eqG g12) S) ) 
                                       then S                         -- en S, se agrega
                                       else S++[g12]      
                         else  S 

concatenable  (MG (G _ (ft1,_) _ )  _ )  (MG (G (fs2,_) _ _) _)   =  (ft1 == fs2)
----------------------------------------------------------------------                                                                



----------------------------------------------------------------------
-- ccat, two multigraphs
--
    
ccat :: MGraph -> MGraph -> MGraph 
ccat (MG (G src _ ar1) cs1) (MG (G _ tgt2 ar2) cs2) = 
             let arches   = map (cartesianOne ar2) ar1    --[[a1:ar2],[a1b,ar2],...]
                 n_arches =  concatMap buildpaths arches
             in  (MG (G src tgt2 n_arches) (cs1++cs2))

cartesianOne archesTarget a1 = (a1:archesTarget)            -- arco1:(arco2a, arco2b, etc)

buildpaths (a:as) = makep a as

makep    _                []    = []
makep  (s,t,o)  ((s2,t2,o2) :as)= 
                  if (t==s2) then (s,t2,(lub0 o o2)):makep (s,t,o) as
                             else makep (s,t,o) as
----------------------------------------------------------------------                                                                



----------------------------------------------------------------------
-- arithmetic of orders
--lubO Equ Equ = Equ
--lub0 Equ GrT = GrT
--lub0 GrT Equ = GrT
--lub0 GrT GrT = GrT 

lub0 x y = if x==GrT  
               then GrT
               else if y==GrT 
                       then GrT
                       else Equ
                  

--------------------------------------------------------------------- 


---------------------------------------------------------------------
-- check if two graphs are equal
--
eqG:: MGraph -> MGraph -> Bool
eqG (MG (G (fs1, as1) (ft1,at1) arrs1) _ ) ( MG (G (fs2,as2) (ft2,at2) arrs2) _ ) =
     if ((fs1==fs2) && (ft1==ft2) && (as1==as2) && (at1==at2) && (eqarrows arrs1 arrs2)) then True 
                                                else False

eqarrows []       []       = True                               --we avoid repeated elems
eqarrows []      (_:_)     = False
eqarrows (_:_)    []       = False
eqarrows (a1:a1s) (a2:a2s) = (eqas (a1:a1s) (a2:a2s)) &&  (eqas (a2:a2s) (a1:a1s) ) && (length (a1:a1s) == length (a2:a2s)) 

                                                --we check if elements of as1 are in as2 
eqas as as2 = not (elem False (map (a_in as2) as)) 

a_in     []   _                 = False
a_in   ((s2,t2,o2):as2) (s,t,o) = if (s==s2) && (t==t2) && (o==o2) then True 
                                         else  a_in as2 (s,t,o)  
---------------------------------------------------------------------





---------------------------------------------------------------------
-- TESTS

G1 = MG (G ("f",2) ("f",2) [(1,1,GrT),(1,2,Equ)]) [(G ("f",2) ("f",2) [(1,1,GrT),(1,2,Equ)])]
G2 = MG (G ("f",2) ("f",2) [(1,2,Equ),(2,1,GrT)]) [(G ("f",2) ("f",2) [(1,2,Equ),(2,1,GrT)])]
G3 = MG (G ("f",2) ("f",2) [(1,2,Equ),(1,1,GrT)]) [(G ("f",2) ("f",2) [(1,1,GrT),(1,2,Equ)])]

G4 = MG (G ("f",2) ("f",2) []) [(G ("f",2) ("f",2) [])]
G5 = MG (G ("f",2) ("f",2) []) [(G ("f",2) ("f",2) [])]




p1 = map (cartesianOne   [(3,4,Equ),(3,4,GrT)]) [(1,1,GrT),(2,2,Equ)]
p2 = ccat G1 G2



------------------------------------------------------------------------------------------

delGRepeated   []   acum = acum
delGRepeated (g:gs) acum = if (elem True (map (eqG g) acum))
                              then delGRepeated gs acum
                              else delGRepeated gs (g:acum)
------------------------------------------------------------------------------------------

eqSet s1 s2  =   (eqStoS s1 s2) && (eqStoS s2 s1)

eqStoS s1 s2 = not (elem False (map (gInS s2) s1)) --se busca cada elem del 1er set en el 2do
                                                   -- si hay un False, elem da True 
gInS S g =  elem True (map (eqG g) S)              -- y lo volteamos a False again



N1 = (MG (G ("main",1) ("pow",2) [(1,1,Equ)]) [(G ("main",1) ("pow",2) [(1,1,Equ)])])
N2 = (MG (G ("pow",2) ("mult",2) [(1,1,Equ)]) [(G ("pow",2) ("mult",2) [(1,1,Equ)])])
N3 = (MG (G ("pow",2) ("pow",2) [(2,2,GrT),(1,1,Equ)]) [(G ("pow",2) ("pow",2) [(2,2,GrT),(1,1,Equ)])])
N4 = (MG (G ("mult",2) ("sum",2) [(2,1,Equ)]) [(G ("mult",2) ("sum",2) [(2,1,Equ)])])
N5 = (MG (G ("mult",2) ("mult",2) [(2,2,Equ),(1,1,GrT)]) [(G ("mult",2) ("mult",2) [(2,2,Equ),(1,1,GrT)])])
N6 = (MG (G ("sum",2) ("sum",2) [(2,2,Equ),(1,1,GrT)]) [(G ("sum",2) ("sum",2) [(2,2,Equ),(1,1,GrT)])])

NL = [N1, N2, N3, N4, N5, N6]
